﻿#!/usr/bin/env python
# -*- coding:utf-8 -*-


import sys
sys.path.append('./gen-py')

from symfoware.thrift import SymThriftServer
from symfoware.thrift.ttypes import *

from thrift import Thrift
from thrift.transport import TSocket
from thrift.transport import TTransport
from thrift.protocol import TBinaryProtocol

Cursor=0
DictCursor=1

class SymConnection():
	
	def __init__(self, host, port):
	    transport = TSocket.TSocket(host, port)
	    self.transport = TTransport.TBufferedTransport(transport)
	    protocol = TBinaryProtocol.TBinaryProtocol(self.transport)
	    
	    self.client = SymThriftServer.Client(protocol)
	    self.transport.open()
	    
	
	def cursor(self, type=0):
		return SymCursor(self.client, type)
		
	def close(self):
		self.transport.close()
		

class SymCursor():
	
	def __init__(self, client, type):
		self.client = client
		self.rs = None
		self.row = None
		self.max = 0
		self.fetch_row = 0
		self.type = type
	
	def execute(self, query):
		#あまりよい方法ではないが・・・
		#select があったらexecuteQuery
		if query.lower().find("select ") != -1:
			self.rs = self.client.executeQuery(query)
			self.fetch_row = 0
			self.max = len(self.rs.SymRows)
		else:
			return self.client.execute(query)
			
	def fetchone(self):
		if self.max <= self.fetch_row:
			return None
		
		self.row = self.rs.SymRows[self.fetch_row].SymRowData
		self.fetch_row += 1
		
		if self.type == 1:
			dict_row = {}
			for i, v in enumerate(self.rs.ColumnNames):
				dict_row[v] = self.row[i]
			self.row = dict_row
		
		return self.row
		
		
	def close(self):
		pass

def connect(host="localhost", port=10251):
	return SymConnection( host, port)



